org.apache.commons.math3.ode.nonstiff

## Class HighamHall54Integrator

- java.lang.Object
- - org.apache.commons.math3.ode.AbstractIntegrator
  - - org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeIntegrator
    - - org.apache.commons.math3.ode.nonstiff.EmbeddedRungeKuttaIntegrator
      - - org.apache.commons.math3.ode.nonstiff.HighamHall54Integrator

- All Implemented Interfaces:
    FirstOrderIntegrator, ODEIntegrator

      public class HighamHall54Integrator
      extends EmbeddedRungeKuttaIntegrator

  This class implements the 5(4) Higham and Hall integrator for Ordinary Differential Equations.

  This integrator is an embedded Runge-Kutta integrator of order 5(4) used in local extrapolation mode (i.e. the solution is computed using the high order formula) with stepsize control (and automatic step initialization) and continuous output. This method uses 7 functions evaluations per step.

  Since:
    1.2
  Version:
    $Id: HighamHall54Integrator.java 1416643 2012-12-03 19:37:14Z tn $

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static String` | `METHOD_NAME` Integrator method name.
    `private static double[][]` | `STATIC_A` Internal weights Butcher array.
    `private static double[]` | `STATIC_B` Propagation weights Butcher array.
    `private static double[]` | `STATIC_C` Time steps Butcher array.
    `private static double[]` | `STATIC_E` Error weights Butcher array.

    - ### Fields inherited from class org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeIntegrator

      `mainSetDimension, scalAbsoluteTolerance, scalRelativeTolerance, vecAbsoluteTolerance, vecRelativeTolerance`

    - ### Fields inherited from class org.apache.commons.math3.ode.AbstractIntegrator

      `isLastStep, resetOccurred, stepHandlers, stepSize, stepStart`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HighamHall54Integrator(double minStep, double maxStep, double[] vecAbsoluteTolerance, double[] vecRelativeTolerance)` Simple constructor.
    `HighamHall54Integrator(double minStep, double maxStep, double scalAbsoluteTolerance, double scalRelativeTolerance)` Simple constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected double` | `estimateError(double[][] yDotK, double[] y0, double[] y1, double h)` Compute the error ratio.
    `int` | `getOrder()` Get the order of the method.

    - ### Methods inherited from class org.apache.commons.math3.ode.nonstiff.EmbeddedRungeKuttaIntegrator

      `getMaxGrowth, getMinReduction, getSafety, integrate, setMaxGrowth, setMinReduction, setSafety`

    - ### Methods inherited from class org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeIntegrator

      `filterStep, getCurrentStepStart, getMaxStep, getMinStep, initializeStep, resetInternalState, sanityChecks, setInitialStepSize, setStepSizeControl, setStepSizeControl`

    - ### Methods inherited from class org.apache.commons.math3.ode.AbstractIntegrator

      `acceptStep, addEventHandler, addEventHandler, addStepHandler, clearEventHandlers, clearStepHandlers, computeDerivatives, getCurrentSignedStepsize, getEvaluations, getEventHandlers, getMaxEvaluations, getName, getStepHandlers, initIntegration, integrate, setEquations, setMaxEvaluations, setStateInitialized`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### METHOD_NAME

          private static final String METHOD_NAME

      Integrator method name.
      See Also:
        Constant Field Values

    - #### STATIC_C

          private static final double[] STATIC_C

      Time steps Butcher array.

    - #### STATIC_A

          private static final double[][] STATIC_A

      Internal weights Butcher array.

    - #### STATIC_B

          private static final double[] STATIC_B

      Propagation weights Butcher array.

    - #### STATIC_E

          private static final double[] STATIC_E

      Error weights Butcher array.

  - ### Constructor Detail

    - #### HighamHall54Integrator

          public HighamHall54Integrator(double minStep,
                                double maxStep,
                                double scalAbsoluteTolerance,
                                double scalRelativeTolerance)

      Simple constructor. Build a fifth order Higham and Hall integrator with the given step bounds
      Parameters:
        `minStep` - minimal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
        `maxStep` - maximal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
        `scalAbsoluteTolerance` - allowed absolute error
        `scalRelativeTolerance` - allowed relative error

    - #### HighamHall54Integrator

          public HighamHall54Integrator(double minStep,
                                double maxStep,
                                double[] vecAbsoluteTolerance,
                                double[] vecRelativeTolerance)

      Simple constructor. Build a fifth order Higham and Hall integrator with the given step bounds
      Parameters:
        `minStep` - minimal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
        `maxStep` - maximal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
        `vecAbsoluteTolerance` - allowed absolute error
        `vecRelativeTolerance` - allowed relative error

  - ### Method Detail

    - #### getOrder

          public int getOrder()

      Get the order of the method.
      Specified by:
        `getOrder` in class `EmbeddedRungeKuttaIntegrator`
      Returns:
        order of the method

    - #### estimateError

          protected double estimateError(double[][] yDotK,
                             double[] y0,
                             double[] y1,
                             double h)

      Compute the error ratio.
      Specified by:
        `estimateError` in class `EmbeddedRungeKuttaIntegrator`
      Parameters:
        `yDotK` - derivatives computed during the first stages
        `y0` - estimate of the step at the start of the step
        `y1` - estimate of the step at the end of the step
        `h` - current step
      Returns:
        error ratio, greater than 1 if step should be rejected

Copyright (c) 2003-2013 Apache Software Foundation